#! /usr/bin/env python

# Locale Prepare
# Copyright (C) 2001-2002 Jean-Baptiste LAMY
#
# This program is free software. See README or LICENSE for the license terms.

"""Locale Prepare

Search all gettext'ed string in the source.
"""

import os, os.path, re, song

START = "gchar *s = N_(\""
END   = "\");"

ids = []

gettext_call = re.compile("""_\([ \t]*"(.*?)"[ \t]*\)""")

dir = os.path.dirname(song.__file__)

for source in filter(lambda filename: filename.endswith(".py"), os.listdir(dir)):
  f = open(os.path.join(dir, source), "r")
  for id in gettext_call.findall(f.read()):
    if not id in ids: ids.append(id)
    
current = open(os.path.join("songwrite", "locale", "fr", "LC_MESSAGES", "songwrite.po")).read()

current_ids = re.findall(r'msgid\s*"([^"]*)"', current)
try: current_ids.remove("")
except: pass

print "  New keys :"
for id in ids:
  if not id in current_ids:
    print "msgid  \"%s\"" % id
    print "msgstr \"%s\"" % id
    
print
print
print "  Deprecated keys :"
for id in current_ids:
  if not id in ids:
    print "msgid  \"%s\"" % id
    
