# Songwrite
# Copyright (C) 2001-2002 Jean-Baptiste LAMY
#
# This program is free software. See README or LICENSE for the license terms.

from __future__ import nested_scopes
import sys, popen2, os, thread, globdef

_p = None

def is_playing(): return _p and (_p.poll() == -1)
def stop():
  global _p
  if not _p is None:
    try: os.kill(_p.pid, 9)
    except OSError: pass
    _p  = None
    
def play__(song, loop = 0, from_time = 0, to_time = sys.maxint):
  stop()
  
  global _p
  if globdef.config.MIDI_USE_TEMP_FILE:
    import tempfile
    file = tempfile.mktemp(".midi")
    open(file, "w").write(song.midi(from_time, to_time))
    _p = popen2.Popen4(globdef.config.MIDI_COMMAND % file)
  else:
    _p = popen2.Popen4(globdef.config.MIDI_COMMAND)
    _p.tochild.write(song.midi(from_time, to_time))
    _p.tochild.flush()

def play(song, loop = 0, from_time = 0, to_time = sys.maxint):
  global _p
  
  while 1:
    if globdef.config.MIDI_USE_TEMP_FILE:
      import tempfile
      file = tempfile.mktemp(".midi")
      open(file, "w").write(song.midi(from_time, to_time))
      _p = p = popen2.Popen4(globdef.config.MIDI_COMMAND % file)
    else:
      _p = p = popen2.Popen4(globdef.config.MIDI_COMMAND)
      _p.tochild.write(song.midi(from_time, to_time))
      _p.tochild.flush()
      
    p.wait()
    if (p.poll() != 0) or (not loop):
      break # Stop if _p has been killed (by stop()) or if not loop !
    

def play_async(song, loop = 0, from_time = 0, to_time = sys.maxint):
  stop()
  thread.start_new_thread(play, (song, loop, from_time, to_time))
  
  
